package mssql_protocol_crawler_go

import (
	"encoding/json"
	"loafle.com/overflow/commons_go/matcher/mssql"
	"loafle.com/overflow/crawler_go"
)

type MSSqlHeahthCrawler struct {
	crawler.SocketHeahthCrawler
}

func (r *MSSqlHeahthCrawler) Internal(params map[string]interface{}) ([]byte, error) {
	
	b, err := r.CheckHeahth(params)
	if err != nil {
		// set error
	}
	return json.Marshal(b)
}
func NewMSSqlHeahthCrawler() *MSSqlHeahthCrawler {
	r := &MSSqlHeahthCrawler{}
	r.SetInternal(r)
	r.SetMatcher(mssql.NewMSSqlMatcher())
	return r
}

//
//import (
//	"encoding/json"
//	"loafle.com/overflow/collector/core/scan/service/matcher/packet"
//	rpc "loafle.com/overflow/of_rpc/json"
//	"loafle.com/overflow/of_rpc/models/param"
//	"loafle.com/overflow/of_rpc/models/protocol"
//	"log"
//	"net"
//	"strconv"
//	"loafle.com/overflow/collector/core/scan/service/matcher/mssql"
//)
//
//////////////// Delegate.Get implement /////////////////
//type MSSQLProtocol struct{}
//
//func (r *MSSQLProtocol) Get(input *param.Input, output *param.Output) error {
//
//	log.Println("data : " + string(input.Data))
//	rr := &protocol.HealthRequest{}
//	json.Unmarshal(input.Data, &rr)
//
//	match, err := check(input.Ip, input.Port)
//
//	rres := &protocol.HealthResponse{IsMatch: match}
//
//	b, err := json.Marshal(&rres)
//	if err != nil {
//		return err
//	}
//	*output = param.Output{Data: b}
//	return nil
//}
//
//func check(ip string, port uint16) (bool, error) {
//
//	var addr string = ip
//	addr += ":"
//	addr += strconv.Itoa(int(port))
//
//	conn, err := net.Dial("tcp", addr)
//	if err != nil {
//		return false, err
//	}
//	defer conn.Close()
//
//	m := mssql.NewMSSqlMatcher()
//
//	for i := 0; i < m.PacketCount(); i++ {
//
//		pack := m.Packet(i)
//		conn.Write(pack.Buffer)
//		bytes := make([]byte, 1024)
//		n, _ := conn.Read(bytes)
//
//		p := packet.NewPacket(bytes, n)
//
//		if m.Match(i, p, nil) == false {
//			return false, nil
//		}
//	}
//
//	return true, nil
//}
//
//func start() {
//	rpc.SetDelegate(new(MSSQLProtocol))
//	err := rpc.StartJSONRPC()
//	if err != nil {
//		log.Fatal(err)
//	}
//}
//
//func main() {
//	start()
//}
